package com.franckbarbier.odbc;

// import java.io.*;
public final class ODBC_test {

    private String _data_source_name;
    private String _user;
    private String _password;
    private java.sql.Connection _connection;

    public ODBC_test() throws java.sql.SQLException { // Note that UCanAccess *DOES NOT* require any ODBC configuration...
        // System.out.println("Please enter information for connecting to ODBC");
        // _data_source_name = readEntry("Data source name within ODBC: ");
        // _user = readEntry("User: ");
//        int slash_index = _user.indexOf('/');
//        if (slash_index != -1) {
//            _password = _user.substring(slash_index + 1);
//            _user = _user.substring(0, slash_index);
//        } else {
//            _password = readEntry("Password: ");
//        }
// https://community.yellowfinbi.com/knowledge-base/article/moving-the-jdbc-odbc-bridge-from-java-7-to-java-8
//        try { // Old JDBC -> ODBC bridge in Java 7, that is no longer present in Java 8...
//            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//        } catch (ClassNotFoundException cnfe) {
//            cnfe.printStackTrace();
//        }
//        _connection = DriverManager.getConnection("jdbc:odbc:" + _data_source_name, _user, _password);
        System.out.println("Working Directory: " + System.getProperty("user.dir"));
        // https://ucanaccess.sourceforge.net/site.html
        _connection = java.sql.DriverManager.getConnection("jdbc:ucanaccess://" + System.getProperty("user.dir") + "/Prison_de_Nantes.mdb;memory=false");
        java.sql.DatabaseMetaData metadata = _connection.getMetaData();
        System.out.println("Product name: " + metadata.getDatabaseProductName() + ", Product version: " + metadata.getDatabaseProductVersion());
        java.sql.ResultSet tables = metadata.getTables(null, null, "Decision", null);
        // Printing the column name and type:
        while (tables.next()) {
            System.out.println("Table name: " + tables.getString("Table_NAME"));
            System.out.println("Table type: " + tables.getString("TABLE_TYPE"));
        }
        _connection.close();
    }

    public void close() {
        try {
            if (_connection != null && !_connection.isClosed()) { // Second member of 'if' is optional since closing an already closed database does not raise any problem...
                _connection.close();
            }
        } catch (java.sql.SQLException sqle) {
            throw new RuntimeException(sqle);
        }
    }

    // Utility function to read a line from standard input stream:
//    static String readEntry(String prompt) {
//        try {
//            StringBuilder buffer = new StringBuilder();
//            System.out.println(prompt);
//            System.out.flush();
//            int c = System.in.read();
//            while (c != '\n' && c != -1) {
//                buffer.append((char) c);
//                c = System.in.read();
//            }
//            return buffer.toString().trim();
//        } catch (IOException ioe) {
//            ioe.printStackTrace();
//            return "Fatal I/O error...";
//        }
//    }
    public static void main(String[] args) {
        ODBC_test test = null;
        try {
            test = new ODBC_test();
        } catch (java.sql.SQLException sqle) {
            sqle.printStackTrace();
        } finally {
            if (test != null) {
                test.close();
            }
        }
    }
}
